package com.haomostudio.so.po;

import com.haomo.plugin.Page;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TCompanyMonthlyBillExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    protected Page page;

    public TCompanyMonthlyBillExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setPage(Page page) {
        this.page=page;
    }

    public Page getPage() {
        return page;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andSpaceIdIsNull() {
            addCriterion("space_id is null");
            return (Criteria) this;
        }

        public Criteria andSpaceIdIsNotNull() {
            addCriterion("space_id is not null");
            return (Criteria) this;
        }

        public Criteria andSpaceIdEqualTo(Integer value) {
            addCriterion("space_id =", value, "spaceId");
            return (Criteria) this;
        }

        public Criteria andSpaceIdNotEqualTo(Integer value) {
            addCriterion("space_id <>", value, "spaceId");
            return (Criteria) this;
        }

        public Criteria andSpaceIdGreaterThan(Integer value) {
            addCriterion("space_id >", value, "spaceId");
            return (Criteria) this;
        }

        public Criteria andSpaceIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("space_id >=", value, "spaceId");
            return (Criteria) this;
        }

        public Criteria andSpaceIdLessThan(Integer value) {
            addCriterion("space_id <", value, "spaceId");
            return (Criteria) this;
        }

        public Criteria andSpaceIdLessThanOrEqualTo(Integer value) {
            addCriterion("space_id <=", value, "spaceId");
            return (Criteria) this;
        }

        public Criteria andSpaceIdIn(List<Integer> values) {
            addCriterion("space_id in", values, "spaceId");
            return (Criteria) this;
        }

        public Criteria andSpaceIdNotIn(List<Integer> values) {
            addCriterion("space_id not in", values, "spaceId");
            return (Criteria) this;
        }

        public Criteria andSpaceIdBetween(Integer value1, Integer value2) {
            addCriterion("space_id between", value1, value2, "spaceId");
            return (Criteria) this;
        }

        public Criteria andSpaceIdNotBetween(Integer value1, Integer value2) {
            addCriterion("space_id not between", value1, value2, "spaceId");
            return (Criteria) this;
        }

        public Criteria andBillNoIsNull() {
            addCriterion("bill_no is null");
            return (Criteria) this;
        }

        public Criteria andBillNoIsNotNull() {
            addCriterion("bill_no is not null");
            return (Criteria) this;
        }

        public Criteria andBillNoEqualTo(String value) {
            addCriterion("bill_no =", value, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoNotEqualTo(String value) {
            addCriterion("bill_no <>", value, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoGreaterThan(String value) {
            addCriterion("bill_no >", value, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoGreaterThanOrEqualTo(String value) {
            addCriterion("bill_no >=", value, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoLessThan(String value) {
            addCriterion("bill_no <", value, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoLessThanOrEqualTo(String value) {
            addCriterion("bill_no <=", value, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoLike(String value) {
            addCriterion("bill_no like", value, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoNotLike(String value) {
            addCriterion("bill_no not like", value, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoIn(List<String> values) {
            addCriterion("bill_no in", values, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoNotIn(List<String> values) {
            addCriterion("bill_no not in", values, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoBetween(String value1, String value2) {
            addCriterion("bill_no between", value1, value2, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillNoNotBetween(String value1, String value2) {
            addCriterion("bill_no not between", value1, value2, "billNo");
            return (Criteria) this;
        }

        public Criteria andBillTitleIsNull() {
            addCriterion("bill_title is null");
            return (Criteria) this;
        }

        public Criteria andBillTitleIsNotNull() {
            addCriterion("bill_title is not null");
            return (Criteria) this;
        }

        public Criteria andBillTitleEqualTo(String value) {
            addCriterion("bill_title =", value, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleNotEqualTo(String value) {
            addCriterion("bill_title <>", value, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleGreaterThan(String value) {
            addCriterion("bill_title >", value, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleGreaterThanOrEqualTo(String value) {
            addCriterion("bill_title >=", value, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleLessThan(String value) {
            addCriterion("bill_title <", value, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleLessThanOrEqualTo(String value) {
            addCriterion("bill_title <=", value, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleLike(String value) {
            addCriterion("bill_title like", value, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleNotLike(String value) {
            addCriterion("bill_title not like", value, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleIn(List<String> values) {
            addCriterion("bill_title in", values, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleNotIn(List<String> values) {
            addCriterion("bill_title not in", values, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleBetween(String value1, String value2) {
            addCriterion("bill_title between", value1, value2, "billTitle");
            return (Criteria) this;
        }

        public Criteria andBillTitleNotBetween(String value1, String value2) {
            addCriterion("bill_title not between", value1, value2, "billTitle");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(Integer value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(Integer value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(Integer value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(Integer value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(Integer value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<Integer> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<Integer> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(Integer value1, Integer value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(Integer value1, Integer value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andRelationMonthIsNull() {
            addCriterion("relation_month is null");
            return (Criteria) this;
        }

        public Criteria andRelationMonthIsNotNull() {
            addCriterion("relation_month is not null");
            return (Criteria) this;
        }

        public Criteria andRelationMonthEqualTo(String value) {
            addCriterion("relation_month =", value, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthNotEqualTo(String value) {
            addCriterion("relation_month <>", value, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthGreaterThan(String value) {
            addCriterion("relation_month >", value, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthGreaterThanOrEqualTo(String value) {
            addCriterion("relation_month >=", value, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthLessThan(String value) {
            addCriterion("relation_month <", value, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthLessThanOrEqualTo(String value) {
            addCriterion("relation_month <=", value, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthLike(String value) {
            addCriterion("relation_month like", value, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthNotLike(String value) {
            addCriterion("relation_month not like", value, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthIn(List<String> values) {
            addCriterion("relation_month in", values, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthNotIn(List<String> values) {
            addCriterion("relation_month not in", values, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthBetween(String value1, String value2) {
            addCriterion("relation_month between", value1, value2, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andRelationMonthNotBetween(String value1, String value2) {
            addCriterion("relation_month not between", value1, value2, "relationMonth");
            return (Criteria) this;
        }

        public Criteria andTotalAmountIsNull() {
            addCriterion("total_amount is null");
            return (Criteria) this;
        }

        public Criteria andTotalAmountIsNotNull() {
            addCriterion("total_amount is not null");
            return (Criteria) this;
        }

        public Criteria andTotalAmountEqualTo(BigDecimal value) {
            addCriterion("total_amount =", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountNotEqualTo(BigDecimal value) {
            addCriterion("total_amount <>", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountGreaterThan(BigDecimal value) {
            addCriterion("total_amount >", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_amount >=", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountLessThan(BigDecimal value) {
            addCriterion("total_amount <", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_amount <=", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountIn(List<BigDecimal> values) {
            addCriterion("total_amount in", values, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountNotIn(List<BigDecimal> values) {
            addCriterion("total_amount not in", values, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_amount between", value1, value2, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_amount not between", value1, value2, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andRentalFeeIsNull() {
            addCriterion("rental_fee is null");
            return (Criteria) this;
        }

        public Criteria andRentalFeeIsNotNull() {
            addCriterion("rental_fee is not null");
            return (Criteria) this;
        }

        public Criteria andRentalFeeEqualTo(BigDecimal value) {
            addCriterion("rental_fee =", value, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andRentalFeeNotEqualTo(BigDecimal value) {
            addCriterion("rental_fee <>", value, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andRentalFeeGreaterThan(BigDecimal value) {
            addCriterion("rental_fee >", value, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andRentalFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("rental_fee >=", value, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andRentalFeeLessThan(BigDecimal value) {
            addCriterion("rental_fee <", value, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andRentalFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("rental_fee <=", value, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andRentalFeeIn(List<BigDecimal> values) {
            addCriterion("rental_fee in", values, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andRentalFeeNotIn(List<BigDecimal> values) {
            addCriterion("rental_fee not in", values, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andRentalFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("rental_fee between", value1, value2, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andRentalFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("rental_fee not between", value1, value2, "rentalFee");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountIsNull() {
            addCriterion("field_service_amount is null");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountIsNotNull() {
            addCriterion("field_service_amount is not null");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountEqualTo(BigDecimal value) {
            addCriterion("field_service_amount =", value, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountNotEqualTo(BigDecimal value) {
            addCriterion("field_service_amount <>", value, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountGreaterThan(BigDecimal value) {
            addCriterion("field_service_amount >", value, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("field_service_amount >=", value, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountLessThan(BigDecimal value) {
            addCriterion("field_service_amount <", value, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("field_service_amount <=", value, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountIn(List<BigDecimal> values) {
            addCriterion("field_service_amount in", values, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountNotIn(List<BigDecimal> values) {
            addCriterion("field_service_amount not in", values, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("field_service_amount between", value1, value2, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andFieldServiceAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("field_service_amount not between", value1, value2, "fieldServiceAmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountIsNull() {
            addCriterion("payed_acmount is null");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountIsNotNull() {
            addCriterion("payed_acmount is not null");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountEqualTo(BigDecimal value) {
            addCriterion("payed_acmount =", value, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountNotEqualTo(BigDecimal value) {
            addCriterion("payed_acmount <>", value, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountGreaterThan(BigDecimal value) {
            addCriterion("payed_acmount >", value, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("payed_acmount >=", value, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountLessThan(BigDecimal value) {
            addCriterion("payed_acmount <", value, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("payed_acmount <=", value, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountIn(List<BigDecimal> values) {
            addCriterion("payed_acmount in", values, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountNotIn(List<BigDecimal> values) {
            addCriterion("payed_acmount not in", values, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("payed_acmount between", value1, value2, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andPayedAcmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("payed_acmount not between", value1, value2, "payedAcmount");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("status is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("status is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("status =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("status <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("status >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("status >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("status <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("status <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("status in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("status not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("status between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("status not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeIsNull() {
            addCriterion("settlement_time is null");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeIsNotNull() {
            addCriterion("settlement_time is not null");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeEqualTo(Date value) {
            addCriterion("settlement_time =", value, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeNotEqualTo(Date value) {
            addCriterion("settlement_time <>", value, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeGreaterThan(Date value) {
            addCriterion("settlement_time >", value, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("settlement_time >=", value, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeLessThan(Date value) {
            addCriterion("settlement_time <", value, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeLessThanOrEqualTo(Date value) {
            addCriterion("settlement_time <=", value, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeIn(List<Date> values) {
            addCriterion("settlement_time in", values, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeNotIn(List<Date> values) {
            addCriterion("settlement_time not in", values, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeBetween(Date value1, Date value2) {
            addCriterion("settlement_time between", value1, value2, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andSettlementTimeNotBetween(Date value1, Date value2) {
            addCriterion("settlement_time not between", value1, value2, "settlementTime");
            return (Criteria) this;
        }

        public Criteria andOverdueDateIsNull() {
            addCriterion("overdue_date is null");
            return (Criteria) this;
        }

        public Criteria andOverdueDateIsNotNull() {
            addCriterion("overdue_date is not null");
            return (Criteria) this;
        }

        public Criteria andOverdueDateEqualTo(Date value) {
            addCriterionForJDBCDate("overdue_date =", value, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andOverdueDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("overdue_date <>", value, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andOverdueDateGreaterThan(Date value) {
            addCriterionForJDBCDate("overdue_date >", value, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andOverdueDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("overdue_date >=", value, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andOverdueDateLessThan(Date value) {
            addCriterionForJDBCDate("overdue_date <", value, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andOverdueDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("overdue_date <=", value, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andOverdueDateIn(List<Date> values) {
            addCriterionForJDBCDate("overdue_date in", values, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andOverdueDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("overdue_date not in", values, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andOverdueDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("overdue_date between", value1, value2, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andOverdueDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("overdue_date not between", value1, value2, "overdueDate");
            return (Criteria) this;
        }

        public Criteria andCreatedIsNull() {
            addCriterion("created is null");
            return (Criteria) this;
        }

        public Criteria andCreatedIsNotNull() {
            addCriterion("created is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedEqualTo(Date value) {
            addCriterion("created =", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedNotEqualTo(Date value) {
            addCriterion("created <>", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedGreaterThan(Date value) {
            addCriterion("created >", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedGreaterThanOrEqualTo(Date value) {
            addCriterion("created >=", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedLessThan(Date value) {
            addCriterion("created <", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedLessThanOrEqualTo(Date value) {
            addCriterion("created <=", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedIn(List<Date> values) {
            addCriterion("created in", values, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedNotIn(List<Date> values) {
            addCriterion("created not in", values, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedBetween(Date value1, Date value2) {
            addCriterion("created between", value1, value2, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedNotBetween(Date value1, Date value2) {
            addCriterion("created not between", value1, value2, "created");
            return (Criteria) this;
        }

        public Criteria andUpdatedIsNull() {
            addCriterion("updated is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedIsNotNull() {
            addCriterion("updated is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedEqualTo(Date value) {
            addCriterion("updated =", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedNotEqualTo(Date value) {
            addCriterion("updated <>", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedGreaterThan(Date value) {
            addCriterion("updated >", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedGreaterThanOrEqualTo(Date value) {
            addCriterion("updated >=", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedLessThan(Date value) {
            addCriterion("updated <", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedLessThanOrEqualTo(Date value) {
            addCriterion("updated <=", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedIn(List<Date> values) {
            addCriterion("updated in", values, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedNotIn(List<Date> values) {
            addCriterion("updated not in", values, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedBetween(Date value1, Date value2) {
            addCriterion("updated between", value1, value2, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedNotBetween(Date value1, Date value2) {
            addCriterion("updated not between", value1, value2, "updated");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodIsNull() {
            addCriterion("confirm_method is null");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodIsNotNull() {
            addCriterion("confirm_method is not null");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodEqualTo(Integer value) {
            addCriterion("confirm_method =", value, "confirmMethod");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodNotEqualTo(Integer value) {
            addCriterion("confirm_method <>", value, "confirmMethod");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodGreaterThan(Integer value) {
            addCriterion("confirm_method >", value, "confirmMethod");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodGreaterThanOrEqualTo(Integer value) {
            addCriterion("confirm_method >=", value, "confirmMethod");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodLessThan(Integer value) {
            addCriterion("confirm_method <", value, "confirmMethod");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodLessThanOrEqualTo(Integer value) {
            addCriterion("confirm_method <=", value, "confirmMethod");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodIn(List<Integer> values) {
            addCriterion("confirm_method in", values, "confirmMethod");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodNotIn(List<Integer> values) {
            addCriterion("confirm_method not in", values, "confirmMethod");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodBetween(Integer value1, Integer value2) {
            addCriterion("confirm_method between", value1, value2, "confirmMethod");
            return (Criteria) this;
        }

        public Criteria andConfirmMethodNotBetween(Integer value1, Integer value2) {
            addCriterion("confirm_method not between", value1, value2, "confirmMethod");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}