package com.haomostudio.so.po;

import com.haomo.plugin.Page;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TPlatformActivityStatisticsExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    protected Page page;

    public TPlatformActivityStatisticsExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setPage(Page page) {
        this.page=page;
    }

    public Page getPage() {
        return page;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDateIsNull() {
            addCriterion("date is null");
            return (Criteria) this;
        }

        public Criteria andDateIsNotNull() {
            addCriterion("date is not null");
            return (Criteria) this;
        }

        public Criteria andDateEqualTo(Date value) {
            addCriterionForJDBCDate("date =", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("date <>", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateGreaterThan(Date value) {
            addCriterionForJDBCDate("date >", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("date >=", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateLessThan(Date value) {
            addCriterionForJDBCDate("date <", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("date <=", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateIn(List<Date> values) {
            addCriterionForJDBCDate("date in", values, "date");
            return (Criteria) this;
        }

        public Criteria andDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("date not in", values, "date");
            return (Criteria) this;
        }

        public Criteria andDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("date between", value1, value2, "date");
            return (Criteria) this;
        }

        public Criteria andDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("date not between", value1, value2, "date");
            return (Criteria) this;
        }

        public Criteria andLookPlayerIsNull() {
            addCriterion("look_player is null");
            return (Criteria) this;
        }

        public Criteria andLookPlayerIsNotNull() {
            addCriterion("look_player is not null");
            return (Criteria) this;
        }

        public Criteria andLookPlayerEqualTo(Integer value) {
            addCriterion("look_player =", value, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLookPlayerNotEqualTo(Integer value) {
            addCriterion("look_player <>", value, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLookPlayerGreaterThan(Integer value) {
            addCriterion("look_player >", value, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLookPlayerGreaterThanOrEqualTo(Integer value) {
            addCriterion("look_player >=", value, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLookPlayerLessThan(Integer value) {
            addCriterion("look_player <", value, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLookPlayerLessThanOrEqualTo(Integer value) {
            addCriterion("look_player <=", value, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLookPlayerIn(List<Integer> values) {
            addCriterion("look_player in", values, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLookPlayerNotIn(List<Integer> values) {
            addCriterion("look_player not in", values, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLookPlayerBetween(Integer value1, Integer value2) {
            addCriterion("look_player between", value1, value2, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLookPlayerNotBetween(Integer value1, Integer value2) {
            addCriterion("look_player not between", value1, value2, "lookPlayer");
            return (Criteria) this;
        }

        public Criteria andLotteryCountIsNull() {
            addCriterion("lottery_count is null");
            return (Criteria) this;
        }

        public Criteria andLotteryCountIsNotNull() {
            addCriterion("lottery_count is not null");
            return (Criteria) this;
        }

        public Criteria andLotteryCountEqualTo(Integer value) {
            addCriterion("lottery_count =", value, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andLotteryCountNotEqualTo(Integer value) {
            addCriterion("lottery_count <>", value, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andLotteryCountGreaterThan(Integer value) {
            addCriterion("lottery_count >", value, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andLotteryCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("lottery_count >=", value, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andLotteryCountLessThan(Integer value) {
            addCriterion("lottery_count <", value, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andLotteryCountLessThanOrEqualTo(Integer value) {
            addCriterion("lottery_count <=", value, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andLotteryCountIn(List<Integer> values) {
            addCriterion("lottery_count in", values, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andLotteryCountNotIn(List<Integer> values) {
            addCriterion("lottery_count not in", values, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andLotteryCountBetween(Integer value1, Integer value2) {
            addCriterion("lottery_count between", value1, value2, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andLotteryCountNotBetween(Integer value1, Integer value2) {
            addCriterion("lottery_count not between", value1, value2, "lotteryCount");
            return (Criteria) this;
        }

        public Criteria andSharePlayerIsNull() {
            addCriterion("share_player is null");
            return (Criteria) this;
        }

        public Criteria andSharePlayerIsNotNull() {
            addCriterion("share_player is not null");
            return (Criteria) this;
        }

        public Criteria andSharePlayerEqualTo(Integer value) {
            addCriterion("share_player =", value, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andSharePlayerNotEqualTo(Integer value) {
            addCriterion("share_player <>", value, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andSharePlayerGreaterThan(Integer value) {
            addCriterion("share_player >", value, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andSharePlayerGreaterThanOrEqualTo(Integer value) {
            addCriterion("share_player >=", value, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andSharePlayerLessThan(Integer value) {
            addCriterion("share_player <", value, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andSharePlayerLessThanOrEqualTo(Integer value) {
            addCriterion("share_player <=", value, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andSharePlayerIn(List<Integer> values) {
            addCriterion("share_player in", values, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andSharePlayerNotIn(List<Integer> values) {
            addCriterion("share_player not in", values, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andSharePlayerBetween(Integer value1, Integer value2) {
            addCriterion("share_player between", value1, value2, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andSharePlayerNotBetween(Integer value1, Integer value2) {
            addCriterion("share_player not between", value1, value2, "sharePlayer");
            return (Criteria) this;
        }

        public Criteria andShareCountIsNull() {
            addCriterion("share_count is null");
            return (Criteria) this;
        }

        public Criteria andShareCountIsNotNull() {
            addCriterion("share_count is not null");
            return (Criteria) this;
        }

        public Criteria andShareCountEqualTo(Integer value) {
            addCriterion("share_count =", value, "shareCount");
            return (Criteria) this;
        }

        public Criteria andShareCountNotEqualTo(Integer value) {
            addCriterion("share_count <>", value, "shareCount");
            return (Criteria) this;
        }

        public Criteria andShareCountGreaterThan(Integer value) {
            addCriterion("share_count >", value, "shareCount");
            return (Criteria) this;
        }

        public Criteria andShareCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("share_count >=", value, "shareCount");
            return (Criteria) this;
        }

        public Criteria andShareCountLessThan(Integer value) {
            addCriterion("share_count <", value, "shareCount");
            return (Criteria) this;
        }

        public Criteria andShareCountLessThanOrEqualTo(Integer value) {
            addCriterion("share_count <=", value, "shareCount");
            return (Criteria) this;
        }

        public Criteria andShareCountIn(List<Integer> values) {
            addCriterion("share_count in", values, "shareCount");
            return (Criteria) this;
        }

        public Criteria andShareCountNotIn(List<Integer> values) {
            addCriterion("share_count not in", values, "shareCount");
            return (Criteria) this;
        }

        public Criteria andShareCountBetween(Integer value1, Integer value2) {
            addCriterion("share_count between", value1, value2, "shareCount");
            return (Criteria) this;
        }

        public Criteria andShareCountNotBetween(Integer value1, Integer value2) {
            addCriterion("share_count not between", value1, value2, "shareCount");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdIsNull() {
            addCriterion("platform_activity_id is null");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdIsNotNull() {
            addCriterion("platform_activity_id is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdEqualTo(Integer value) {
            addCriterion("platform_activity_id =", value, "platformActivityId");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdNotEqualTo(Integer value) {
            addCriterion("platform_activity_id <>", value, "platformActivityId");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdGreaterThan(Integer value) {
            addCriterion("platform_activity_id >", value, "platformActivityId");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("platform_activity_id >=", value, "platformActivityId");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdLessThan(Integer value) {
            addCriterion("platform_activity_id <", value, "platformActivityId");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdLessThanOrEqualTo(Integer value) {
            addCriterion("platform_activity_id <=", value, "platformActivityId");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdIn(List<Integer> values) {
            addCriterion("platform_activity_id in", values, "platformActivityId");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdNotIn(List<Integer> values) {
            addCriterion("platform_activity_id not in", values, "platformActivityId");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdBetween(Integer value1, Integer value2) {
            addCriterion("platform_activity_id between", value1, value2, "platformActivityId");
            return (Criteria) this;
        }

        public Criteria andPlatformActivityIdNotBetween(Integer value1, Integer value2) {
            addCriterion("platform_activity_id not between", value1, value2, "platformActivityId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}