package com.haomostudio.so.po;

import com.haomo.plugin.Page;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TOrderFieldExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    protected Page page;

    public TOrderFieldExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setPage(Page page) {
        this.page=page;
    }

    public Page getPage() {
        return page;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNull() {
            addCriterion("order_id is null");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNotNull() {
            addCriterion("order_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrderIdEqualTo(Integer value) {
            addCriterion("order_id =", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotEqualTo(Integer value) {
            addCriterion("order_id <>", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThan(Integer value) {
            addCriterion("order_id >", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("order_id >=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThan(Integer value) {
            addCriterion("order_id <", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThanOrEqualTo(Integer value) {
            addCriterion("order_id <=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdIn(List<Integer> values) {
            addCriterion("order_id in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotIn(List<Integer> values) {
            addCriterion("order_id not in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdBetween(Integer value1, Integer value2) {
            addCriterion("order_id between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotBetween(Integer value1, Integer value2) {
            addCriterion("order_id not between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andFieldIdIsNull() {
            addCriterion("field_id is null");
            return (Criteria) this;
        }

        public Criteria andFieldIdIsNotNull() {
            addCriterion("field_id is not null");
            return (Criteria) this;
        }

        public Criteria andFieldIdEqualTo(Integer value) {
            addCriterion("field_id =", value, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldIdNotEqualTo(Integer value) {
            addCriterion("field_id <>", value, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldIdGreaterThan(Integer value) {
            addCriterion("field_id >", value, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("field_id >=", value, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldIdLessThan(Integer value) {
            addCriterion("field_id <", value, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldIdLessThanOrEqualTo(Integer value) {
            addCriterion("field_id <=", value, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldIdIn(List<Integer> values) {
            addCriterion("field_id in", values, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldIdNotIn(List<Integer> values) {
            addCriterion("field_id not in", values, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldIdBetween(Integer value1, Integer value2) {
            addCriterion("field_id between", value1, value2, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldIdNotBetween(Integer value1, Integer value2) {
            addCriterion("field_id not between", value1, value2, "fieldId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdIsNull() {
            addCriterion("field_snapshot_id is null");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdIsNotNull() {
            addCriterion("field_snapshot_id is not null");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdEqualTo(Integer value) {
            addCriterion("field_snapshot_id =", value, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdNotEqualTo(Integer value) {
            addCriterion("field_snapshot_id <>", value, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdGreaterThan(Integer value) {
            addCriterion("field_snapshot_id >", value, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("field_snapshot_id >=", value, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdLessThan(Integer value) {
            addCriterion("field_snapshot_id <", value, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdLessThanOrEqualTo(Integer value) {
            addCriterion("field_snapshot_id <=", value, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdIn(List<Integer> values) {
            addCriterion("field_snapshot_id in", values, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdNotIn(List<Integer> values) {
            addCriterion("field_snapshot_id not in", values, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdBetween(Integer value1, Integer value2) {
            addCriterion("field_snapshot_id between", value1, value2, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andFieldSnapshotIdNotBetween(Integer value1, Integer value2) {
            addCriterion("field_snapshot_id not between", value1, value2, "fieldSnapshotId");
            return (Criteria) this;
        }

        public Criteria andBookDateIsNull() {
            addCriterion("book_date is null");
            return (Criteria) this;
        }

        public Criteria andBookDateIsNotNull() {
            addCriterion("book_date is not null");
            return (Criteria) this;
        }

        public Criteria andBookDateEqualTo(String value) {
            addCriterion("book_date =", value, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateNotEqualTo(String value) {
            addCriterion("book_date <>", value, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateGreaterThan(String value) {
            addCriterion("book_date >", value, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateGreaterThanOrEqualTo(String value) {
            addCriterion("book_date >=", value, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateLessThan(String value) {
            addCriterion("book_date <", value, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateLessThanOrEqualTo(String value) {
            addCriterion("book_date <=", value, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateLike(String value) {
            addCriterion("book_date like", value, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateNotLike(String value) {
            addCriterion("book_date not like", value, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateIn(List<String> values) {
            addCriterion("book_date in", values, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateNotIn(List<String> values) {
            addCriterion("book_date not in", values, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateBetween(String value1, String value2) {
            addCriterion("book_date between", value1, value2, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookDateNotBetween(String value1, String value2) {
            addCriterion("book_date not between", value1, value2, "bookDate");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeIsNull() {
            addCriterion("book_start_time is null");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeIsNotNull() {
            addCriterion("book_start_time is not null");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeEqualTo(String value) {
            addCriterion("book_start_time =", value, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeNotEqualTo(String value) {
            addCriterion("book_start_time <>", value, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeGreaterThan(String value) {
            addCriterion("book_start_time >", value, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeGreaterThanOrEqualTo(String value) {
            addCriterion("book_start_time >=", value, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeLessThan(String value) {
            addCriterion("book_start_time <", value, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeLessThanOrEqualTo(String value) {
            addCriterion("book_start_time <=", value, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeLike(String value) {
            addCriterion("book_start_time like", value, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeNotLike(String value) {
            addCriterion("book_start_time not like", value, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeIn(List<String> values) {
            addCriterion("book_start_time in", values, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeNotIn(List<String> values) {
            addCriterion("book_start_time not in", values, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeBetween(String value1, String value2) {
            addCriterion("book_start_time between", value1, value2, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookStartTimeNotBetween(String value1, String value2) {
            addCriterion("book_start_time not between", value1, value2, "bookStartTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeIsNull() {
            addCriterion("book_end_time is null");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeIsNotNull() {
            addCriterion("book_end_time is not null");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeEqualTo(String value) {
            addCriterion("book_end_time =", value, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeNotEqualTo(String value) {
            addCriterion("book_end_time <>", value, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeGreaterThan(String value) {
            addCriterion("book_end_time >", value, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeGreaterThanOrEqualTo(String value) {
            addCriterion("book_end_time >=", value, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeLessThan(String value) {
            addCriterion("book_end_time <", value, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeLessThanOrEqualTo(String value) {
            addCriterion("book_end_time <=", value, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeLike(String value) {
            addCriterion("book_end_time like", value, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeNotLike(String value) {
            addCriterion("book_end_time not like", value, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeIn(List<String> values) {
            addCriterion("book_end_time in", values, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeNotIn(List<String> values) {
            addCriterion("book_end_time not in", values, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeBetween(String value1, String value2) {
            addCriterion("book_end_time between", value1, value2, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andBookEndTimeNotBetween(String value1, String value2) {
            addCriterion("book_end_time not between", value1, value2, "bookEndTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNull() {
            addCriterion("start_time is null");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNotNull() {
            addCriterion("start_time is not null");
            return (Criteria) this;
        }

        public Criteria andStartTimeEqualTo(Integer value) {
            addCriterion("start_time =", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotEqualTo(Integer value) {
            addCriterion("start_time <>", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThan(Integer value) {
            addCriterion("start_time >", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThanOrEqualTo(Integer value) {
            addCriterion("start_time >=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThan(Integer value) {
            addCriterion("start_time <", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThanOrEqualTo(Integer value) {
            addCriterion("start_time <=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeIn(List<Integer> values) {
            addCriterion("start_time in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotIn(List<Integer> values) {
            addCriterion("start_time not in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeBetween(Integer value1, Integer value2) {
            addCriterion("start_time between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotBetween(Integer value1, Integer value2) {
            addCriterion("start_time not between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNull() {
            addCriterion("end_time is null");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNotNull() {
            addCriterion("end_time is not null");
            return (Criteria) this;
        }

        public Criteria andEndTimeEqualTo(Integer value) {
            addCriterion("end_time =", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotEqualTo(Integer value) {
            addCriterion("end_time <>", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThan(Integer value) {
            addCriterion("end_time >", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThanOrEqualTo(Integer value) {
            addCriterion("end_time >=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThan(Integer value) {
            addCriterion("end_time <", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThanOrEqualTo(Integer value) {
            addCriterion("end_time <=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIn(List<Integer> values) {
            addCriterion("end_time in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotIn(List<Integer> values) {
            addCriterion("end_time not in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeBetween(Integer value1, Integer value2) {
            addCriterion("end_time between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotBetween(Integer value1, Integer value2) {
            addCriterion("end_time not between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andCreatedIsNull() {
            addCriterion("created is null");
            return (Criteria) this;
        }

        public Criteria andCreatedIsNotNull() {
            addCriterion("created is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedEqualTo(Date value) {
            addCriterion("created =", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedNotEqualTo(Date value) {
            addCriterion("created <>", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedGreaterThan(Date value) {
            addCriterion("created >", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedGreaterThanOrEqualTo(Date value) {
            addCriterion("created >=", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedLessThan(Date value) {
            addCriterion("created <", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedLessThanOrEqualTo(Date value) {
            addCriterion("created <=", value, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedIn(List<Date> values) {
            addCriterion("created in", values, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedNotIn(List<Date> values) {
            addCriterion("created not in", values, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedBetween(Date value1, Date value2) {
            addCriterion("created between", value1, value2, "created");
            return (Criteria) this;
        }

        public Criteria andCreatedNotBetween(Date value1, Date value2) {
            addCriterion("created not between", value1, value2, "created");
            return (Criteria) this;
        }

        public Criteria andUpdatedIsNull() {
            addCriterion("updated is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedIsNotNull() {
            addCriterion("updated is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedEqualTo(Date value) {
            addCriterion("updated =", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedNotEqualTo(Date value) {
            addCriterion("updated <>", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedGreaterThan(Date value) {
            addCriterion("updated >", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedGreaterThanOrEqualTo(Date value) {
            addCriterion("updated >=", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedLessThan(Date value) {
            addCriterion("updated <", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedLessThanOrEqualTo(Date value) {
            addCriterion("updated <=", value, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedIn(List<Date> values) {
            addCriterion("updated in", values, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedNotIn(List<Date> values) {
            addCriterion("updated not in", values, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedBetween(Date value1, Date value2) {
            addCriterion("updated between", value1, value2, "updated");
            return (Criteria) this;
        }

        public Criteria andUpdatedNotBetween(Date value1, Date value2) {
            addCriterion("updated not between", value1, value2, "updated");
            return (Criteria) this;
        }

        public Criteria andPriceIsNull() {
            addCriterion("price is null");
            return (Criteria) this;
        }

        public Criteria andPriceIsNotNull() {
            addCriterion("price is not null");
            return (Criteria) this;
        }

        public Criteria andPriceEqualTo(BigDecimal value) {
            addCriterion("price =", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotEqualTo(BigDecimal value) {
            addCriterion("price <>", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThan(BigDecimal value) {
            addCriterion("price >", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("price >=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThan(BigDecimal value) {
            addCriterion("price <", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("price <=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceIn(List<BigDecimal> values) {
            addCriterion("price in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotIn(List<BigDecimal> values) {
            addCriterion("price not in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("price between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("price not between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andHourIsNull() {
            addCriterion("hour is null");
            return (Criteria) this;
        }

        public Criteria andHourIsNotNull() {
            addCriterion("hour is not null");
            return (Criteria) this;
        }

        public Criteria andHourEqualTo(BigDecimal value) {
            addCriterion("hour =", value, "hour");
            return (Criteria) this;
        }

        public Criteria andHourNotEqualTo(BigDecimal value) {
            addCriterion("hour <>", value, "hour");
            return (Criteria) this;
        }

        public Criteria andHourGreaterThan(BigDecimal value) {
            addCriterion("hour >", value, "hour");
            return (Criteria) this;
        }

        public Criteria andHourGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("hour >=", value, "hour");
            return (Criteria) this;
        }

        public Criteria andHourLessThan(BigDecimal value) {
            addCriterion("hour <", value, "hour");
            return (Criteria) this;
        }

        public Criteria andHourLessThanOrEqualTo(BigDecimal value) {
            addCriterion("hour <=", value, "hour");
            return (Criteria) this;
        }

        public Criteria andHourIn(List<BigDecimal> values) {
            addCriterion("hour in", values, "hour");
            return (Criteria) this;
        }

        public Criteria andHourNotIn(List<BigDecimal> values) {
            addCriterion("hour not in", values, "hour");
            return (Criteria) this;
        }

        public Criteria andHourBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hour between", value1, value2, "hour");
            return (Criteria) this;
        }

        public Criteria andHourNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hour not between", value1, value2, "hour");
            return (Criteria) this;
        }

        public Criteria andMinIsNull() {
            addCriterion("min is null");
            return (Criteria) this;
        }

        public Criteria andMinIsNotNull() {
            addCriterion("min is not null");
            return (Criteria) this;
        }

        public Criteria andMinEqualTo(Integer value) {
            addCriterion("min =", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinNotEqualTo(Integer value) {
            addCriterion("min <>", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinGreaterThan(Integer value) {
            addCriterion("min >", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinGreaterThanOrEqualTo(Integer value) {
            addCriterion("min >=", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinLessThan(Integer value) {
            addCriterion("min <", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinLessThanOrEqualTo(Integer value) {
            addCriterion("min <=", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinIn(List<Integer> values) {
            addCriterion("min in", values, "min");
            return (Criteria) this;
        }

        public Criteria andMinNotIn(List<Integer> values) {
            addCriterion("min not in", values, "min");
            return (Criteria) this;
        }

        public Criteria andMinBetween(Integer value1, Integer value2) {
            addCriterion("min between", value1, value2, "min");
            return (Criteria) this;
        }

        public Criteria andMinNotBetween(Integer value1, Integer value2) {
            addCriterion("min not between", value1, value2, "min");
            return (Criteria) this;
        }

        public Criteria andSetupLockIsNull() {
            addCriterion("setup_lock is null");
            return (Criteria) this;
        }

        public Criteria andSetupLockIsNotNull() {
            addCriterion("setup_lock is not null");
            return (Criteria) this;
        }

        public Criteria andSetupLockEqualTo(Integer value) {
            addCriterion("setup_lock =", value, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupLockNotEqualTo(Integer value) {
            addCriterion("setup_lock <>", value, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupLockGreaterThan(Integer value) {
            addCriterion("setup_lock >", value, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupLockGreaterThanOrEqualTo(Integer value) {
            addCriterion("setup_lock >=", value, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupLockLessThan(Integer value) {
            addCriterion("setup_lock <", value, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupLockLessThanOrEqualTo(Integer value) {
            addCriterion("setup_lock <=", value, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupLockIn(List<Integer> values) {
            addCriterion("setup_lock in", values, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupLockNotIn(List<Integer> values) {
            addCriterion("setup_lock not in", values, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupLockBetween(Integer value1, Integer value2) {
            addCriterion("setup_lock between", value1, value2, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupLockNotBetween(Integer value1, Integer value2) {
            addCriterion("setup_lock not between", value1, value2, "setupLock");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordIsNull() {
            addCriterion("setup_password is null");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordIsNotNull() {
            addCriterion("setup_password is not null");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordEqualTo(Integer value) {
            addCriterion("setup_password =", value, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordNotEqualTo(Integer value) {
            addCriterion("setup_password <>", value, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordGreaterThan(Integer value) {
            addCriterion("setup_password >", value, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordGreaterThanOrEqualTo(Integer value) {
            addCriterion("setup_password >=", value, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordLessThan(Integer value) {
            addCriterion("setup_password <", value, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordLessThanOrEqualTo(Integer value) {
            addCriterion("setup_password <=", value, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordIn(List<Integer> values) {
            addCriterion("setup_password in", values, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordNotIn(List<Integer> values) {
            addCriterion("setup_password not in", values, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordBetween(Integer value1, Integer value2) {
            addCriterion("setup_password between", value1, value2, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andSetupPasswordNotBetween(Integer value1, Integer value2) {
            addCriterion("setup_password not between", value1, value2, "setupPassword");
            return (Criteria) this;
        }

        public Criteria andStaffCodeIsNull() {
            addCriterion("staff_code is null");
            return (Criteria) this;
        }

        public Criteria andStaffCodeIsNotNull() {
            addCriterion("staff_code is not null");
            return (Criteria) this;
        }

        public Criteria andStaffCodeEqualTo(Integer value) {
            addCriterion("staff_code =", value, "staffCode");
            return (Criteria) this;
        }

        public Criteria andStaffCodeNotEqualTo(Integer value) {
            addCriterion("staff_code <>", value, "staffCode");
            return (Criteria) this;
        }

        public Criteria andStaffCodeGreaterThan(Integer value) {
            addCriterion("staff_code >", value, "staffCode");
            return (Criteria) this;
        }

        public Criteria andStaffCodeGreaterThanOrEqualTo(Integer value) {
            addCriterion("staff_code >=", value, "staffCode");
            return (Criteria) this;
        }

        public Criteria andStaffCodeLessThan(Integer value) {
            addCriterion("staff_code <", value, "staffCode");
            return (Criteria) this;
        }

        public Criteria andStaffCodeLessThanOrEqualTo(Integer value) {
            addCriterion("staff_code <=", value, "staffCode");
            return (Criteria) this;
        }

        public Criteria andStaffCodeIn(List<Integer> values) {
            addCriterion("staff_code in", values, "staffCode");
            return (Criteria) this;
        }

        public Criteria andStaffCodeNotIn(List<Integer> values) {
            addCriterion("staff_code not in", values, "staffCode");
            return (Criteria) this;
        }

        public Criteria andStaffCodeBetween(Integer value1, Integer value2) {
            addCriterion("staff_code between", value1, value2, "staffCode");
            return (Criteria) this;
        }

        public Criteria andStaffCodeNotBetween(Integer value1, Integer value2) {
            addCriterion("staff_code not between", value1, value2, "staffCode");
            return (Criteria) this;
        }

        public Criteria andPasswordIsNull() {
            addCriterion("password is null");
            return (Criteria) this;
        }

        public Criteria andPasswordIsNotNull() {
            addCriterion("password is not null");
            return (Criteria) this;
        }

        public Criteria andPasswordEqualTo(String value) {
            addCriterion("password =", value, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordNotEqualTo(String value) {
            addCriterion("password <>", value, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordGreaterThan(String value) {
            addCriterion("password >", value, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordGreaterThanOrEqualTo(String value) {
            addCriterion("password >=", value, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordLessThan(String value) {
            addCriterion("password <", value, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordLessThanOrEqualTo(String value) {
            addCriterion("password <=", value, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordLike(String value) {
            addCriterion("password like", value, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordNotLike(String value) {
            addCriterion("password not like", value, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordIn(List<String> values) {
            addCriterion("password in", values, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordNotIn(List<String> values) {
            addCriterion("password not in", values, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordBetween(String value1, String value2) {
            addCriterion("password between", value1, value2, "password");
            return (Criteria) this;
        }

        public Criteria andPasswordNotBetween(String value1, String value2) {
            addCriterion("password not between", value1, value2, "password");
            return (Criteria) this;
        }

        public Criteria andBookStartDateIsNull() {
            addCriterion("book_start_date is null");
            return (Criteria) this;
        }

        public Criteria andBookStartDateIsNotNull() {
            addCriterion("book_start_date is not null");
            return (Criteria) this;
        }

        public Criteria andBookStartDateEqualTo(Date value) {
            addCriterion("book_start_date =", value, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookStartDateNotEqualTo(Date value) {
            addCriterion("book_start_date <>", value, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookStartDateGreaterThan(Date value) {
            addCriterion("book_start_date >", value, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookStartDateGreaterThanOrEqualTo(Date value) {
            addCriterion("book_start_date >=", value, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookStartDateLessThan(Date value) {
            addCriterion("book_start_date <", value, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookStartDateLessThanOrEqualTo(Date value) {
            addCriterion("book_start_date <=", value, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookStartDateIn(List<Date> values) {
            addCriterion("book_start_date in", values, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookStartDateNotIn(List<Date> values) {
            addCriterion("book_start_date not in", values, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookStartDateBetween(Date value1, Date value2) {
            addCriterion("book_start_date between", value1, value2, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookStartDateNotBetween(Date value1, Date value2) {
            addCriterion("book_start_date not between", value1, value2, "bookStartDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateIsNull() {
            addCriterion("book_end_date is null");
            return (Criteria) this;
        }

        public Criteria andBookEndDateIsNotNull() {
            addCriterion("book_end_date is not null");
            return (Criteria) this;
        }

        public Criteria andBookEndDateEqualTo(Date value) {
            addCriterion("book_end_date =", value, "bookEndDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateNotEqualTo(Date value) {
            addCriterion("book_end_date <>", value, "bookEndDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateGreaterThan(Date value) {
            addCriterion("book_end_date >", value, "bookEndDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateGreaterThanOrEqualTo(Date value) {
            addCriterion("book_end_date >=", value, "bookEndDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateLessThan(Date value) {
            addCriterion("book_end_date <", value, "bookEndDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateLessThanOrEqualTo(Date value) {
            addCriterion("book_end_date <=", value, "bookEndDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateIn(List<Date> values) {
            addCriterion("book_end_date in", values, "bookEndDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateNotIn(List<Date> values) {
            addCriterion("book_end_date not in", values, "bookEndDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateBetween(Date value1, Date value2) {
            addCriterion("book_end_date between", value1, value2, "bookEndDate");
            return (Criteria) this;
        }

        public Criteria andBookEndDateNotBetween(Date value1, Date value2) {
            addCriterion("book_end_date not between", value1, value2, "bookEndDate");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}